//import MUNDERKENNUNG
import gab.opencv.*;
import processing.video.*;
import java.awt.*;


//import WINKELBERECHNUNG
import org.apache.commons.math3.analysis.MultivariateMatrixFunction;
import org.apache.commons.math3.linear.*;
import org.apache.commons.math3.analysis.MultivariateVectorFunction;
import org.apache.commons.math3.linear.MatrixUtils;
import org.apache.commons.math3.linear.SingularValueDecomposition;

//import DATENÜBERTRAGUNG
import processing.serial.*;   //verwende die 'Serial' Library


//WINKELBERECHNUNG
RealVector winkelVector = MatrixUtils.createRealVector( new double [] {0, 0, 0}); //Aktuelle Position des Arms
RealVector ZielPunkt = endEffectorPosCalc(0, 0, 0).getSubVector(0, 3);

  float winkelServo1;
  float winkelServo2;
  float winkelServo3;

//DATENÜBERTRAGUNG
Serial myPort;   // Deklariere ein Object vom Typ 'Serial', mit dem Namen 'myPort'

void setup(){
  size(800, 600);                    //starte Bildschirmausgabe

//MUNDERKENNUNG
  setupMunderkennung();                //rufe Funktion 'setupMunderkennung' auf

 
//DATENÜBERTRAGUNG
  setupDatenuebertragung();
}

void draw() {

//MUNDERKENNUNG
  RealVector zielPunkt = drawMunderkennung();                 //rufe Funktion 'drawMunderkennung' auf

 
//WINKELBERECHNUNG
  println("ZielPunkt"+zielPunkt);
  winkelVector = gibWinkel(zielPunkt, winkelVector);


//DATENUEBERTRAGUNG
  drawDatenuebertragung();
}